#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys

# ################################################################################################
def parseToc(filename):
    level = 0
    #construction de l'expression rgulire qui trouvera le ul
    reUl = re.compile("<ul>", re.IGNORECASE)
    #construction de l'expression rgulire qui trouvera le /ul
    reUlEnd = re.compile("</ul>")
    #construction de l'expression rgulire qui trouvera le param file
    reParamFile = re.compile("<param name=\"Local\" value=\"(.*?)\">", re.IGNORECASE)
    #construction de l'expression rgulire qui trouvera le param title
    reParamTitle = re.compile("<param name=\"Name\" value=\"(.*?)\">", re.IGNORECASE)
    
    #sur chaque ligne:
    #si on est sur ul ou /ul, updater level
    #si on est sur param, ajouter la value au bon level dans la hierarchy
    for oneLine in tocLines:
        if reUl.search(oneLine):
            level = level + 1
        elif reUlEnd.search(oneLine):
            del filesHierarchy[level]
            del titlesHierarchy[level]
            level = level - 1
        elif len(reParamTitle.findall(oneLine)) != 0:
            title = reParamTitle.findall(oneLine)
            titlesHierarchy[level] = title[0]
        elif len(reParamFile.findall(oneLine)) != 0:
            value = reParamFile.findall(oneLine)
            filesHierarchy[level] = value[0]
            if value[0] == filename:
                break
    
    print filesHierarchy
    print titlesHierarchy
# ################################################################################################
def buildBackgroundCode(product, section):
    code = ""
    sectionFile = {}
    #dfinition des images pour PICOLOU4U8U16H264
    sectionFile["PICOLOU4U8U16H264Installation"] = "BackgroundMetrovert.png"
    sectionFile["PICOLOU4U8U16H264Hardware Reference"] = "BackgroundMetro.png"
    sectionFile["PICOLOU4U8U16H264DirectShow Reference"] = "BackgroundAirport.png"
    sectionFile["PICOLOU4U8U16H264Virtual File System Reference"] = "BackgroundAirport.png"
    sectionFile["PICOLOU4U8U16H264Resources Identification (Software)"] = "BackgroundTrain.png"
    sectionFile["PICOLOU4U8U16H264Glossary"] = "BackgroundWalking.png"
    #dfinition des images pour PICOLOV16H264
    sectionFile["PICOLOV16H264Installation"] = "BackgroundMetrovert.png"
    sectionFile["PICOLOV16H264Hardware Reference"] = "BackgroundMetro.png"
    sectionFile["PICOLOV16H264DirectShow Reference"] = "BackgroundAirport.png"
    sectionFile["PICOLOV16H264Virtual File System Reference"] = "BackgroundAirport.png"
    sectionFile["PICOLOV16H264Resources Identification (Software)"] = "BackgroundTrain.png"
    sectionFile["PICOLOV16H264Glossary"] = "BackgroundWalking.png"
    #dfinition des images pour PICOLOU4H264PCI104
    sectionFile["PICOLOU4H264PCI104Installation"] = "BackgroundHighway.png"
    sectionFile["PICOLOU4H264PCI104Hardware Reference"] = "BackgroundWharf.png"
    sectionFile["PICOLOU4H264PCI104DirectShow Reference"] = "BackgroundEmptyTrain.png"
    sectionFile["PICOLOU4H264PCI104Virtual File System Reference"] = "BackgroundEmptyTrain.png"
    sectionFile["PICOLOU4H264PCI104Resources Identification (Software)"] = "BackgroundTrain.png"
    sectionFile["PICOLOU4H264PCI104Glossary"] = "BackgroundTrain.png"
    #ici, je laisse Documentation ds le product. Pq on peut pas le laisser pr les autres ci-dessus?
    #dfinition des images pour ConnectingAccessoriesforPICOLOH264Documentation
    sectionFile["ConnectingAccessoriesforPICOLOH264DocumentationConnecting Accessories Overview"] = "BackgroundMetrovert.png"
    sectionFile["ConnectingAccessoriesforPICOLOH264DocumentationBreakout Cables"] = "BackgroundMetro.png"
    sectionFile["ConnectingAccessoriesforPICOLOH264DocumentationAdapters"] = "BackgroundAirport.png"
    sectionFile["ConnectingAccessoriesforPICOLOH264DocumentationLinks"] = "BackgroundEmptyTrain.png"
    sectionFile["ConnectingAccessoriesforPICOLOH264DocumentationConnectivity Solutions"] = "BackgroundWalking.png"
    if section == "Main":
        code = "<SCRIPT type=\"text/javascript\">\n"
        code = code + "\t<!--\n"
        code = code + "\tif (navigator.platform.indexOf(\"Win\") != -1) {\n"
        code = code + "\tvar MM_contentVersion = 7;\n"
        code = code + "\tvar plugin = (navigator.mimeTypes && navigator.mimeTypes[\"application/x-shockwave-flash\"]) ? navigator.mimeTypes[\"application/x-shockwave-flash\"].enabledPlugin : 0;\n"
        code = code + "\tif ( plugin ) {\n"
        code = code + "\t\tvar words = navigator.plugins[\"Shockwave Flash\"].description.split(\" \");\n"
        code = code + "\t\tfor (var i = 0; i < words.length; ++i) {\n"
        code = code + "\t\t\tif (isNaN(parseInt(words[i])))\n"
        code = code + "\t\t\t\tcontinue;\n"
        code = code + "\t\t\tvar MM_PluginVersion = words[i];\n"
        code = code + "\t\t}\n"
        code = code + "\t\tvar MM_FlashCanPlay = MM_PluginVersion >= MM_contentVersion;\n"
        code = code + "\t}\n"
        code = code + "\telse if (navigator.userAgent && navigator.userAgent.indexOf(\"MSIE\")>=0 && (navigator.appVersion.indexOf(\"Win\") != -1)) {\n"
        code = code + "\t\tdocument.write('<SCR' + 'IPT LANGUAGE=VBScript\> \\n'); //FS hide this from IE4.5 Mac by splitting the tag\n"
        code = code + "\t\tdocument.write('on error resume next \\n');\n"
        code = code + "\t\tdocument.write('MM_FlashCanPlay = ( IsObject(CreateObject(\"ShockwaveFlash.ShockwaveFlash.\" & MM_contentVersion)))\\n');\n"
        code = code + "\t\tdocument.write('</SCR' + 'IPT\> \\n');\n"
        code = code + "\t}\n"
        code = code + "\tif ( MM_FlashCanPlay ) {\n"
        code = code + "\t\tdocument.write('<OBJECT classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\" codebase=\"http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0\" width=\"400\" height=\"1299\" id=\"fullscreen\">');\n"
        code = code + "\t\tdocument.write(' <PARAM name=\"allowScriptAccess\" value=\"sameDomain\" /> ');\n"
        code = code + "\t\tdocument.write(' <PARAM name=\"movie\" value=\"" + product + "BackgroundMain.swf\" /> ');\n"
        code = code + "\t\tdocument.write(' <PARAM name=\"allowFullScreen\" value=\"true\" /> ');\n"
        code = code + "\t\tdocument.write(' <PARAM value=\"transparent\" name=\"wmode\" /> ');\n"
        code = code + "\t\tdocument.write(' <PARAM value=\"transparent\" name=\"embed\" /> ');\n"
        code = code + "\t\tdocument.write(' <PARAM name=\"quality\" value=\"high\" /> ');\n"
        code = code + "\t\tdocument.write(' <EMBED src=\"" + product + "BackgroundMain.swf\" QUALITY=\"high\" WMODE=\"transparent\" EMBED=\"transparent\" allowFullScreen=\"true\" width=\"400\" height=\"1299\" ');\n"
        code = code + "\t\tdocument.write(' NAME=\"fullscreen\" allowScriptAccess=\"sameDomain\" TYPE=\"application/x-shockwave-flash\" PLUGINSPAGE=\"http://www.macromedia.com/go/getflashplayer\" />');\n"
        code = code + "\t\tdocument.write(' </EMBED>');\n"
        code = code + "\t\tdocument.write(' </OBJECT>');\n"
        code = code + "\t}\n"
        code = code + "\telse {\n"
        code = code + "\t\tdocument.write('<IMG SRC=\"" + product + "BackgroundMain.png\" WIDTH=\"400\" HEIGHT=\"1299\" usemap=\"#version_check\" BORDER=0>');\n"
        code = code + "\t}\n"
        code = code + "\t}\n"
        code = code + "\telse {\n"
        code = code + "\t\tdocument.write('<IMG SRC=\"" + product + "BackgroundMain.png\" WIDTH=\"400\" HEIGHT=\"1299\" usemap=\"#version_check\" BORDER=0>');\n"
        code = code + "\t}\n"
        code = code + "\t//-->\n"
        code = code + "</SCRIPT><NOSCRIPT><IMG SRC=\"" + product + "BackgroundMain.png\" WIDTH=\"400\" HEIGHT=\"1299\" usemap=\"#version_check\" BORDER=0></NOSCRIPT>\n"
    else:
        code = "<IMG id='' alt='' src='" + sectionFile[product + section] + "' hspace='0' vspace='0' border='0'>"
    return code
# ################################################################################################
def getInnerHierarchy():
    innerHierarchy = ""
    #pour chaque level, crer le <a> et l'ajouter  la chane globale qu'on collera dans le fichier.htm
    for k in filesHierarchy.keys():
        link = "<a href=\"" + filesHierarchy[k] + "\" target=\"_self\" title=\"" + filesHierarchy[k] + "\">" + titlesHierarchy[k] + "</a>" + " &gt; "
        #concatner tous les <a>
        innerHierarchy = innerHierarchy + link

    #enlever les 3 derniers caractres de la chane ( > )
    innerHierarchy = innerHierarchy.rstrip(" &gt;")
    #print innerHierarchy
        
    return innerHierarchy
    
# ################################################################################################

#trouver le type d'lment qu'on a: ul, /ul, li, param...
#reElem = re.compile("<(.*?)[> ]", re.IGNORECASE)
#elementType = reElem.findall(oneLine)


#message de dbut
print "----------<IncludeHierarchy.py>----------"

#ouverture de la toc et constitution d'un tableau contenant toutes les lignes du fichier
tocLines = euresys.readLinesFromFile("toc.hhc")

#excution sur tous les fichiers htm du dossier
for f in os.listdir('.'):
    if euresys.getFileExtension(f) != ".htm":
      continue    

    #il faut un dictionnaire pour les titres des topics, un autre dictionnaire pour les filenames des topics
    #les deux voluent paralllement, avec key = level
    filesHierarchy = dict()
    titlesHierarchy = dict()

    #which product is this about?
    product = euresys.getJobName()
    product = product.replace("_VFS_Documentation", "")
    product = product.replace("_DS_Documentation", "")
    product = product.replace("_", "")
    print "Current product: " + product
    
    #in which section are we?
    #if 1 of the 4 2nd-level sections: section = ["Installation", "HR", "DR", "VFSR", "Glossary"] >>> background = image
    #if not (cover or empty pages): section = "Main" >>> background = animation
    section = "Main"

    #parser la toc et extraire la hierarchy du fichier pass en paramtre
    parseToc(f)

    #ouvrir le fichier
    htmlTxt = euresys.readFromFile(f)

    #trouver l'endroit ou crire la hierarchy
    reLocation = re.compile("<!-- here comes the hierarchy -->", re.IGNORECASE)
    reBackground = re.compile("<!-- here comes the relevant background -->", re.IGNORECASE)
    location = reLocation.findall(htmlTxt)
    if len(location) != 0:
        htmlTxt = htmlTxt.replace(location[0], getInnerHierarchy())
        #in which section are we?    
        if len(titlesHierarchy) > 1:
            section = titlesHierarchy[2]
        bkg = reBackground.findall(htmlTxt)
        if len(bkg) != 0:
            htmlTxt = htmlTxt.replace(bkg[0], buildBackgroundCode(product, section))
        
        #crire dans le fichier
        euresys.writeToFile(f, htmlTxt)

############################################################################################################################
#rcuprer le filename associ au 1er item de la hierarchy
filename = filesHierarchy[1]
print "First topic found in the hierarchy = " + filename
#crire ce filename dans index.htm pour tre sr qu'il soit utilis comme page d'entre
#(n'est plus le cas dans les VUx series)
indexTxt = euresys.readFromFile("index.htm")
reMainTopic = re.compile("var strReturn = \"(.*?\.htm)\"")
founds = reMainTopic.findall(indexTxt)
if len(founds) == 1:
    print "Main topic found in index.htm = " + founds[0]
    if founds[0] != filename:
        indexTxt = indexTxt.replace(founds[0], filename)
        euresys.writeToFile("index.htm", indexTxt)
    
#message de fin
print "----------</IncludeHierarchy.py>----------"
