#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys

# ################################################################################################
def parseToc():
    level = 0
    #construction de l'expression rgulire qui trouvera le ul
    reUl = re.compile("<ul>", re.IGNORECASE)
    #construction de l'expression rgulire qui trouvera le /ul
    reUlEnd = re.compile("</ul>", re.IGNORECASE)
    #construction de l'expression rgulire qui trouvera le param file
    reParamFile = re.compile("<param name=\"Local\" value=\"(.*?)\">", re.IGNORECASE)
    #construction de l'expression rgulire qui trouvera le param title
    reParamTitle = re.compile("<param name=\"Name\" value=\"(.*?)\">", re.IGNORECASE)
    
    #sur chaque ligne:
    #si on est sur ul ou /ul, updater level
    #si on est sur param, ajouter la value au bon tableau
    for oneLine in tocLines:
        if reUl.search(oneLine):
            level = level + 1
        elif reUlEnd.search(oneLine):
            #del filesInToc[level]
            #del titlesInToc[level]
            level = level - 1
        elif len(reParamTitle.findall(oneLine)) != 0:
            title = reParamTitle.findall(oneLine)
            #je ne remets pas l'index dans la toc
            if title[0] != "Index":
                titles.append(title[0])
                levels.append(level)
        elif len(reParamFile.findall(oneLine)) != 0:
            filename = reParamFile.findall(oneLine)
            #je ne remets pas l'index dans la toc
            if filename[0] != "indexpage.htm":
                filenames.append(filename[0])
    
    print levels
    print titles
    print filenames
# ################################################################################################


#<p class="toc2"><a href="9182.htm"><img src="topic.gif">&nbsp;Foreword</a></p>
# ################################################################################################
def getHtmlToc():
    htmlToc = ""
    #pour chaque level, crer la ligne html et l'ajouter  la chane globale qu'on collera dans la toc.htm
    #attention que cette ligne est un peu diffrente selon le level et selon book/topic
    #si le level qui suit le current level est plus grand, a veut dire que le current level est un book
    #si le current level est un book, ajouter la <DIV>
    #attention aussi aux </DIV>
    #le dernier level est toujours un topic
    
    for i in xrange(len(levels) - 1):
        #comparer le niveau du current topic avec le niveau du topic suivant
        sum = levels[i] - levels[i + 1]
        if sum < 0:
            #il s'agit d'un book
            if levels[i] < 2:
                p = "<p class='toc" + oct(levels[i]) + "'><img id='minus' src='minus.gif' alt='Collapse' onClick='updateToc(this)' align='absbottom'>&nbsp;<a href='" + filenames[i] + "'>" + titles[i] + "</a></p>\n<DIV class='visible'>\n"
            else:
                p = "<p class='toc" + oct(levels[i]) + "'><img id='plus' src='plus.gif' alt='Expand' onClick='updateToc(this)' align='absbottom'>&nbsp;<a href='" + filenames[i] + "'>" + titles[i] + "</a></p>\n<DIV class='invisible'>\n"
        else:
            #il s'agit d'un topic
            #trouver si le topic est le dernier de son book, voire de ses sub-books successifs...
            if sum > 0:
                #le topic est le dernier de son book, voire de ses sub-books successifs
                p = "<p class='toc" + oct(levels[i]) + "'><a href='" + filenames[i] + "'>" + titles[i] + "</a></p>\n"
                #mettre autant de </DIV> que de sub-books  fermer
                for j in xrange(0, sum):
                    p = p + "</DIV>\n"
            else: #sum = 0
                #le topic n'est pas le dernier de son book
                p = "<p class='toc" + oct(levels[i]) + "'><a href='" + filenames[i] + "'>" + titles[i] + "</a></p>\n"
        #concatner tous les <p>
        htmlToc = htmlToc + p
    #le dernier est toujours un topic
    p = "<p class='toc" + oct(levels[len(levels) - 1]) +"'><a href='" + filenames[len(levels) - 1] + "'>" + titles[len(levels) - 1] +"</a></p>\n"
    #concatner aussi le dernier <p>
    htmlToc = htmlToc + p
    #mettre autant de </DIV> que de niveaux  fermer
    for j in xrange(levels[i] - 1):
        htmlToc = htmlToc + "</DIV>\n"
    htmlToc = htmlToc + "</DIV>\n"
    
    #print htmlToc
    return htmlToc
    
# ################################################################################################

#trouver le type d'lment qu'on a: ul, /ul, li, param...
#reElem = re.compile("<(.*?)[> ]", re.IGNORECASE)
#elementType = reElem.findall(oneLine)


#message de dbut
print "----------<InsertTocInCover.py>----------"

try:
    #ouverture de la toc et constitution d'un tableau contenant toutes les lignes du fichier
    tocLines = euresys.readLinesFromFile("toc.hhc")

    #il faut 3 tableaux: titre du topic, filename du topic, level
    #ils voluent en parallle
    titles = []
    filenames = []
    levels = []

    #parser la toc et remplir les 3 tableaux
    parseToc()

    #ouvrir le fichier htm de cover (strictement pour QST ici,  automatiser au cas o)
    tocFile = open("73567.htm","r+")
    tocTxt = tocFile.read()
    tocFile.close()

    #trouver l'endroit ou crire la toc
    reLocation = re.compile("<!-- here comes the toc -->", re.IGNORECASE)
    location = reLocation.findall(tocTxt)
    print len(location)
    if len(location) != 0:
        tocTxt = tocTxt.replace(location[0], getHtmlToc())
        
        #crire dans le fichier cover (QST only)
        euresys.writeToFile("73567.htm", tocTxt)

except IOError:
  print "No toc to write."
  
#message de fin
print "----------</InsertTocInCover.py>----------"
