REM skip the display of command lines
REM -----------------------------------
@echo off

REM clear the screen
REM -----------------------------------
cls

REM move to the Publishing folder (given as argument in the AIT publishing profile)
REM -----------------------------------
echo Processing Python scripts in %1...
cd %1

REM get the project name from the current folder
REM -----------------------------------
SET _PROJECT=%CD:*\=%
SET _PROJECT=%_PROJECT:*\=%
SET _PROJECT=%_PROJECT:*\=%
SET _PROJECT=%_PROJECT:*\=%
SET _PROJECT=%_PROJECT:*\=%
SET _PROJECT=%_PROJECT:*\=%
SET _PROJECT=%_PROJECT:*\=%

REM **********************************************************************

REM Everything in this IF clause is specific to the MultiCam Reference parameter topics.
IF "%_PROJECT%" == "MultiCam_Boards_Documentation" (
	echo Starting ReplaceCodeDivs...
	ReplaceCodeDivs.py >> log.txt

	echo Starting TuneScopeTables...
	TuneScopeTables.py >> log.txt

	echo Starting InsertParameterTitle...
	InsertParameterTitle.py >> log.txt
)

echo Starting RewriteNavigation...
RewriteNavigation.py >> log.txt

echo Starting IncludeHierarchy...
IncludeHierarchy.py >> log.txt

echo Starting RemoveUnneededText...
RemoveUnneededText.py >> log.txt

echo Starting RewriteSpecialChars...
RewriteSpecialChars.py >> log.txt

echo Starting AdjustContext...
AdjustContext.py >> log.txt

echo Starting ImproveTables...
ImproveTables.py >> log.txt

echo Starting AdjustCover...
AdjustCover.py >> log.txt

echo Starting RewriteEnhancedPopups...
RewriteEnhancedPopups.py >> log.txt

echo Starting ImproveManualIndex...
ImproveManualIndex.py >> log.txt

IF "%_PROJECT%" == "Open_eVision_Eval_Quick_Start_Tutorials" (
	echo Starting InsertTocInCover...
	InsertTocInCover.py >> log.txt
)

IF "%_PROJECT%" == "Open_eVision_Studio_Quick_Start_Tutorials" (
	echo Starting InsertTocInCover...
	InsertTocInCover.py >> log.txt
)

IF "%_PROJECT%" == "Open_eVision_Cpp_Documentation" (
	echo Starting AddCppGettersSettersIntoIndex...
	AddCppGettersSettersIntoIndex.py >> log.txt
	echo Starting SplitApisIntoIndex...
	SplitApisIntoIndex.py >> log.txt
)

IF "%_PROJECT%" == "Open_eVision_DotNet_Documentation" (
	echo Starting SplitApisIntoIndex...
	SplitApisIntoIndex.py >> log.txt
	echo RewriteSeparator...
	RewriteSeparator >> log.txt
)

IF "%_PROJECT%" == "Open_eVision_ActiveX_Documentation" (
	echo Starting SplitApisIntoIndex...
	SplitApisIntoIndex.py >> log.txt
	echo RewriteSeparator...
	RewriteSeparator >> log.txt
)
IF "%_PROJECT%" == "Open_eVision_Functional_Guide" (
	echo Starting AdaptCssToFunctionalGuideOnly...
	AdaptCssToFunctionalGuideOnly.py >> log.txt
)

echo Starting InsertBuildNumber...
InsertBuildNumber.py >> log.txt

echo Starting InsertCurrentYear...
InsertCurrentYear.py >> log.txt

echo -----------------------------------
echo Htm files have been post-processed.

REM **********************************************************************

echo Starting AdaptIndexAndTocToPlainHtml...
AdaptIndexAndTocToPlainHtml.py >> log.txt

echo Starting WriteTocHtm...
WriteTocHtm.py >> log.txt

echo Starting WriteIndexHtm...
WriteIndexHtm.py >> log.txt

echo Copying %1 in the Intranet Documentation _DRAFT folder...
PutHtmOnIntranetDraft.py >> log.txt

REM ----------------------------------- following command (intranet indexation) added by MHD - 13/09/2010

echo Indexing Intranet %_PROJECT% folder with Zoom Search Engine...
"C:\Program Files\Zoom Search Engine 5.0\ZoomIndexer.exe" -c -o "%_PROJECT%_DRAFT.zcfg" >> log.txt

REM -----------------------------------

echo Sending Notification Email...
SendUpdatedPublicationNotificationEmail.py >> log.txt

pause