#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import shutil
import urllib
import euresys

##Clean hhp file, to remove templates or scripts files.
##We don't want those files to be visible, or to be indexed and found via the Search feature.
##This script is executed after CHM publication ONLY.

#start message
print "----------<RemoveUnneededFilesFromHhp.py>----------"

#all defined files below will be removed from the hhp file
definedFiles = [".*\.py", ".*\.bat", "BuildsFile\.txt", "log\.txt"]
definedFiles.extend(["blank\.gif", "cbook\.gif", "obook\.gif", "minus\.gif", "plus\.gif", "tail\.gif", "topic\.gif", "Contents\d\.gif", "Index\d\.gif", "Search\d\.gif"])
definedFiles.extend(["html_frameset\.htm", "indexpage\.htm", "formIndex\.htm", "wholeIndex\.htm", "tab_index\.htm", "tab_search\.htm", "tab_toc\.htm", "toc\.css", "toc\.htm", "index\.htm"])
definedFiles.extend(["Cover\.htm", "Empty\.htm", "Main\.htm", "Normal\.htm", "Parameter\.htm", "topic\.htm", "project\.hhp", "stylesheet\.css"])
definedFiles.extend(["PICOLOV16H264 SP\.htm", "LACI\.htm", "LDCI\.htm", "MC SP\.htm", "Oe SP\.htm"])
definedFiles.extend(["PICOLO V16 H264\.htm", "DOMINO series\.htm", "GRABLINK series\.htm", "PICOLO series\.htm", "MultiCam\.htm", "MultiCam Boards Documentation\.htm"])
definedFiles.extend(["Open eVision Quick Start Tutorials.htm", "Open eVision ActiveX Reference\.htm", "Open eVision C\+\+ Reference\.htm", "Open eVision NET Reference\.htm", "Open eVision User Guide\.htm", "Open eVision Documentation\.htm"])
definedFiles.extend(["BoardMapping\.htm", "ChannelMapping\.htm", "ConfigurationMapping\.htm", "SurfaceMapping\.htm"])

#searched is a list of Python regular expressions, built upon definedFiles
searched = list()
for eachDefinedFile in definedFiles:
  reFileLine = re.compile(eachDefinedFile + "\n", re.IGNORECASE)
  searched.append(reFileLine)


#read the current job hhp file
jobName = os.path.split(os.path.abspath("."))[1]
hhpTxt = euresys.readFromFile(jobName + ".hhp")

flag = "False"

#replace each found regular expression by an empty string  
for eachSearched in searched:    
  founds = eachSearched.findall(hhpTxt)
  if len(founds) != 0:
      flag = "True"
      for eachFound in founds:
          hhpTxt = hhpTxt.replace(eachFound, "")

if flag == "True":
  euresys.writeToFile(jobName + ".hhp", hhpTxt)

#end message
print "----------</RemoveUnneededFilesFromHhp.py>----------"

