#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys

#message de dbut
print "----------<SplitApisIntoIndex.py>----------"

#dans le fichier index.hhk
#trouver les entres contenant <param name="Name" value="class + separator + method">
#reconstituer un nouvelle entre et l'ajouter  l'index
#trier l'index sur le critre du titre de l'item

# ################################################################################################
# fct qui construit le code ncessaire autour du titre de l'entre et du fichier target
def buildNewEntry(title, target):
  newEntry = ""
  newEntry += "<LI> <OBJECT type=\"text/sitemap\">\n"
  newEntry += "\t<param name=\"Name\" value=\"" + title + "\">\n"
  newEntry += "\t<param name=\"Local\" value=\"" + target + "\">\n"
  newEntry += "\t</OBJECT>\n\n"
  return newEntry
# ################################################################################################
 
listOfItems = []

#adaptation de la syntaxe  la current API (via nom du dossier parent)
reCpp = re.compile("Cpp")
reDotNet = re.compile("DotNet")
reActiveX = re.compile("ActiveX")
jobName = os.path.split(os.path.abspath("."))[1]
if reCpp.search(jobName):
  separator = "::"
if reDotNet.search(jobName):
  separator = "\."
if reActiveX.search(jobName):
  separator = "\."

#Expressions rgulires  
# \S+? means at least 1 "non-white" character (as few as possible - non greedy)
reEntry = re.compile("<param name=\"Name\" value=\"((\S+?)" + separator + "(\S+?))\">\s*?<param name=\"Local\" value=\"(\S+?\.htm)\">")
reEndIndex = re.compile("</UL>\s*?</BODY></HTML>")
reItem = re.compile("(<LI>\s*?<OBJECT type=\"text/sitemap\">\s*?<param name=\"Name\" value=\")(.*?\">.*?</OBJECT>)", re.DOTALL)

## ###############################################################################

#ouverture et lecture de l'index
indexTxt = euresys.readFromFile("index.hhk")

flag = "False"

############################ ajouter les entres ##################################
#rechercher les reEntry  
entries = reEntry.findall(indexTxt)
if len(entries) != 0:
  for eachEntry in entries:
    #construire la newEntry en fonction de ce qu'on a trouv    
    title = eachEntry[2] + " (" + eachEntry[1] + ")"
    target = eachEntry[3]
    newEntry = buildNewEntry(title, target)

    #ajouter la newEntry en fin d'index
    endIndex = reEndIndex.findall(indexTxt)
    if len(endIndex) == 1:
      indexTxt = indexTxt.replace(endIndex[0], newEntry + "</UL>\n</BODY></HTML>")

################################# trier les entres #############################
#lister tous les reItem
items = reItem.findall(indexTxt)
if len(items) != 0:
  for eachItem in items:
    #ajouter chaque item  la liste
    listOfItems.append([eachItem[1], eachItem[0]])

  #trier la liste
  listOfItems.sort(euresys.cmpLower)

  #reconstituer l'index  partir de cette liste trie
  newIndexTxt = ""
  newIndexTxt += "<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML//EN\">\n<HTML>\n<HEAD></HEAD>\n<BODY>\n<OBJECT type=\"text/site properties\">\n\t<param name=\"FrameName\" value=\"BODY\">\n\t<param name=\"ExWindow Styles\" value=\"0x0\">\n\t<param name=\"Window Styles\" value=\"0x7\">\n</OBJECT>\n<UL>\n"
  for eachItem in listOfItems:
    newIndexTxt += eachItem[1] + eachItem[0] + "\n"
  newIndexTxt += "</UL>\n</BODY></HTML>"
  
  #index modifi
  flag = "True"


if flag == "True":
  euresys.writeToFile("index.hhk", newIndexTxt)

#message de fin
print "----------</SplitApisIntoIndex.py>----------"

