#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys

# ################################################################################################
def parseIndex():
    level = 1
    #construction de l'expression rgulire qui trouvera le param title
    reLi = re.compile("<LI> <OBJECT type=.*?", re.IGNORECASE)
    #construction de l'expression rgulire qui trouvera le param title
    reParamTitle = re.compile("<param name=\"Name\" value=\"(.*?)\">", re.IGNORECASE)
    #construction de l'expression rgulire qui trouvera le param file
    reParamFile = re.compile("<param name=\"Local\" value=\"(.*?)\">", re.IGNORECASE)
    
    #sur chaque ligne:
    #si on est sur ul ou /ul, updater level
    #si on est sur param, ajouter la value au bon tableau
    for oneLine in indexLines:
        if oneLine.find("<ul>") != -1:
            level = level + 1
        elif oneLine.find("</ul>") != -1:
            #del filesInToc[level]
            #del titlesInToc[level]
            level = level - 1
        elif reLi.search(oneLine):
            #dans la ligne suivante, rechercher le title
            #s.index(x) retourne l'index du 1er x trouv dans s >> avant de recommencer la boucle, il faudra supprimer oneLine aprs s'en tre servi,
            #pour ne pas continuellement retomber sur le mme index retourn
            titleLine = indexLines[indexLines.index(oneLine) + 1]
            if len(reParamTitle.findall(titleLine)) != 0:
                title = reParamTitle.findall(titleLine)
                titles.append(title[0])
            #dans la 2e ligne suivante, rechercher le filename
            filenameLine = indexLines[indexLines.index(oneLine) + 2]
            if len(reParamFile.findall(filenameLine)) != 0:
                filename = reParamFile.findall(filenameLine)
                filenames.append(filename[0])
                levels.append(level)
            #enlever la ligne <LI> pour tre sr de ne plus retomber dessus
            indexLines.remove(oneLine)
    
    #idalement, il faudrait comparer les deux listes paralllement, et supprimer les redondances
    #genre if titles[i] = titles[j] ET filenames[i] = filenames[j], supprimer 1 des 2

    print "len(levels) = %d" %len(levels)
    print "len(titles) = %d" %len(titles)
    print "len(filenames) = %d" %len(filenames)
    
# ################################################################################################


#<tr valign='top'><td class='indexlink' nowrap='nowrap'><a href='36199.htm'>2M30-SA</a><br></td></tr>
# ################################################################################################
def getHtmlIndex():
    #construction de l'expression rgulire pour dsactiver le lien
    reEmptyLink = re.compile("(<a href='javascript:void\(0\)'>)<span class='nohighlight'>.*?</span>(</a>)", re.IGNORECASE)
    
    #pour chaque level, crer la ligne html et l'ajouter  la chane globale qu'on collera dans indexpage.htm
    #attention que le style css de cette ligne est diffrent selon le level
    
    htmlIndex = ""
    
    for i in xrange(len(filenames)):
        p = "<tr valign='top'><td class='index" + oct(levels[i]) + "' nowrap='nowrap'><a href='" + filenames[i] + "'><span class='nohighlight'>" + titles[i] + "</span></a><br></td></tr>\n"
        #concatner chaque nouveau <p>
        htmlIndex = htmlIndex + p

    #dsactiver le lien au lieu javascript:void(0)
    emptyLinks = reEmptyLink.findall(htmlIndex)
    if len(emptyLinks) != 0:
        for emptyLink in emptyLinks:
            htmlIndex = htmlIndex.replace(emptyLink[0], "")
            htmlIndex = htmlIndex.replace(emptyLink[1], "")
    
    #print htmlIndex
    return htmlIndex
    
# ################################################################################################

#message de dbut
print "----------<WriteIndexHtm.py>----------"

try:
    #ouverture de l'index et constitution d'un tableau contenant toutes les lignes du fichier
    indexLines = euresys.readLinesFromFile("index.hhk")

    #il faut 3 tableaux: titre du topic, filename du topic, level
    #ils voluent en parallle
    titles = []
    filenames = []
    levels = []

    #parser l'index et remplir les 3 tableaux
    parseIndex()
    
    #ouvrir le fichier wholeIndex.htm
    indexTxt = euresys.readFromFile("wholeIndex.htm")

    #trouver l'endroit ou crire l'index
    location = "<!-- ici viendra l'index -->"
    if indexTxt.find(location) != -1:
        indexTxt = indexTxt.replace(location, getHtmlIndex())
        
        #crire dans le fichier
        euresys.writeToFile("wholeIndex.htm", indexTxt)

except IOError:
  print "No index to write."
  
#message de fin
print "----------</WriteIndexHtm.py>----------"
