#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import euresys

# ################################################################################################
def parseToc():
    level = 1
    #construction de l'expression rgulire qui trouvera le param file
    reParamFile = re.compile("<param name=\"Local\" value=\"(.*?)\">", re.IGNORECASE)
    #construction de l'expression rgulire qui trouvera le param title
    reParamTitle = re.compile("<param name=\"Name\" value=\"(.*?)\">", re.IGNORECASE)
    
    #sur chaque ligne:
    #si on est sur ul ou /ul, updater level
    #si on est sur param, ajouter la value au bon tableau
    for oneLine in tocLines:
        if oneLine.find("<ul>") != -1:
            level = level + 1
        elif oneLine.find("</ul>") != -1:
            #del filesInToc[level]
            #del titlesInToc[level]
            level = level - 1
        elif len(reParamTitle.findall(oneLine)) != 0:
            title = reParamTitle.findall(oneLine)
            #je ne remets pas l'index dans la toc
            if title[0] != "Index":
                titles.append(title[0])
                levels.append(level)
        elif len(reParamFile.findall(oneLine)) != 0:
            filename = reParamFile.findall(oneLine)
            #je ne remets pas l'index dans la toc
            if filename[0] != "indexpage.htm":
                filenames.append(filename[0])
    
    print levels
    print titles
    print filenames
# ################################################################################################


#<p class="toc2"><a href="9182.htm"><img src="topic.gif">&nbsp;Foreword</a></p>
# ################################################################################################
def getHtmlToc():
    htmlToc = ""
    #pour chaque level, crer la ligne html et l'ajouter  la chane globale qu'on collera dans la toc.htm
    #attention que cette ligne est un peu diffrente selon le level et selon book/topic
    #si le level qui suit le current level est plus grand, a veut dire que le current level est un book
    #si le current level est un book, ajouter la <DIV>
    #attention aussi aux </DIV>
    #le dernier level est toujours un topic
    
    for i in xrange(len(levels) - 1):
        #comparer le niveau du current topic avec le niveau du topic suivant
        sum = levels[i] - levels[i + 1]
        if sum < 0:
            #il s'agit d'un book
            if levels[i] < 2:
                p = "<p class='toc" + oct(levels[i]) + "'><img id='minus' src='minus.gif' alt='Collapse' onClick='updateToc(this)'><a href='" + filenames[i] + "'><img src='obook.gif'>&nbsp;<span id='" + filenames[i] + "' class='nohighlight'>" + titles[i] + "</span></a></p>\n<DIV class='visible'>\n"
            else:
                p = "<p class='toc" + oct(levels[i]) + "'><img id='plus' src='plus.gif' alt='Expand' onClick='updateToc(this)'><a href='" + filenames[i] + "'><img src='cbook.gif'>&nbsp;<span id='" + filenames[i] + "' class='nohighlight'>" + titles[i] + "</span></a></p>\n<DIV class='invisible'>\n"
        else:
            #il s'agit d'un topic
            #trouver si le topic est le dernier de son book, voire de ses sub-books successifs...
            if sum > 0:
                #le topic est le dernier de son book, voire de ses sub-books successifs
                p = "<p class='toc" + oct(levels[i]) + "'><a href='" + filenames[i] + "'><img src='blank.gif'><img src='topic.gif'>&nbsp;<span id='" + filenames[i] + "' class='nohighlight'>" + titles[i] + "</span></a></p>\n"
                #mettre autant de </DIV> que de sub-books  fermer
                for j in xrange(0, sum):
                    p = p + "</DIV>\n"
            else: #sum = 0
                #le topic n'est pas le dernier de son book
                p = "<p class='toc" + oct(levels[i]) + "'><a href='" + filenames[i] + "'><img src='blank.gif'><img src='topic.gif'>&nbsp;<span id='" + filenames[i] + "' class='nohighlight'>" + titles[i] + "</span></a></p>\n"
        #concatner tous les <p>
        htmlToc = htmlToc + p
    #le dernier est toujours un topic
    p = "<p class='toc" + oct(levels[len(levels) - 1]) +"'><a href='" + filenames[len(levels) - 1] + "'><img src='blank.gif'><img src='topic.gif'>&nbsp;<span id='" + filenames[len(levels) - 1] + "' class='nohighlight'>" + titles[len(levels) - 1] +"</span></a></p>\n"
    #concatner aussi le dernier <p>
    htmlToc = htmlToc + p
    #mettre autant de </DIV> que de niveaux  fermer
    for j in xrange(levels[i] - 1):
        htmlToc = htmlToc + "</DIV>\n"
    
    #print htmlToc
    return htmlToc
    
# ################################################################################################



#message de dbut
print "----------<WriteTocHtm.py>----------"

try:
    #ouverture de la toc et constitution d'un tableau contenant toutes les lignes du fichier
    tocLines = euresys.readLinesFromFile("toc.hhc")

    #il faut 3 tableaux: titre du topic, filename du topic, level
    #ils voluent en parallle
    titles = []
    filenames = []
    levels = []

    #parser la toc et remplir les 3 tableaux
    parseToc()

    #ouvrir le fichier toc.htm
    tocTxt = euresys.readFromFile("toc.htm")

    #trouver l'endroit ou crire la toc
    location = "<!-- ici viendra la toc -->"
    if tocTxt.find(location) != -1:
        tocTxt = tocTxt.replace(location, getHtmlToc())
        
        #crire dans le fichier
        euresys.writeToFile("toc.htm", tocTxt)

except IOError:
  print "No toc to write."
  
#message de fin
print "----------</WriteTocHtm.py>----------"
