#!/usr/bin/python
# -*- coding: latin-1 -*-

import re
import os
import glob

#################################################################################################
#retourne le nom du fichier (12345.htm) correspondant au title pass en argument (se sert de index.hhk)
def getFileName(title):
  filename = ""
  hhkTxt = readFromFile("index.hhk")
  #trouver dans la toc le filename associ  title
  reTitle = re.compile("<param name=\"Name\" value=\"" + title + "\">.*?<param name=\"Local\" value=\"(.*?)\">", re.DOTALL)
  filenames = reTitle.findall(hhkTxt)
  if len(filenames) == 1:
    filename = filenames[0]
  return filename
#erreurs: le title n'est pas trouv dans index.hhk. le title est trouv plusieurs fois.



#################################################################################################
#retourne l'extension du fichier pass en argument ("." inclus -> ".htm", ".hhk", ...)
def getFileExtension(filePath):
  extension = os.path.splitext(filePath)[-1]
  #print "File extension = " + extension
  return extension



#################################################################################################
#retourne le filename sans extension du fichier pass en argument
def getFileNameWoExtension(filePath):
  filename = os.path.splitext(filePath)[0]
  #print "Filename without extension = " + filename
  return filename



#################################################################################################
#retourne le type de projet en cours (dossier grand-parent "Draft HTM", "Draft HTM + Local CHM", ...)
def getJobType():
  jobType = os.path.split(os.path.split(os.path.abspath("."))[0])[1]
  print "jobType = " + jobType
  return jobType


#################################################################################################
#retourne le nom de projet en cours (dossier parent)
def getJobName():
  jobName = os.path.split(os.path.abspath("."))[1]
  print "jobName = " + jobName
  return jobName



#################################################################################################
#retourne une string avec tout le contenu du fichier pass comme argument
def readFromFile(filePath):
  #the file must already exist, and is opened is read-only mode
  try:
    file = open(filePath,"r")
    txt = file.read()
    file.close()
    return txt
  except IOError:
    print "ERROR: The file " + filePath + " does not exist."
    return ""
  

    
#################################################################################################
#retourne une liste de strings avec les lignes du fichier pass comme argument
def readLinesFromFile(filePath):
  #the file must already exist, and is opened is read-only mode
  try:
    file = open(filePath,"r")
    list = file.readlines()
    file.close()
    return list
  except IOError:
    print "ERROR: The file " + filePath + " does not exist."
    return []


    
#################################################################################################
#remplace le contenu du fichier en 1er argument par le contenu pass en 2e argument
def writeToFile(filePath, contents):
  #if the file does not already exist, it is created, in write-only mode
  try:
    file = open(filePath,"w+")
    file.write(contents)
    print "The file " + filePath + " has been modified."
    file.close()
  except IOError:
    print "ERROR: The file " + filePath + " could not be modified/created."



#################################################################################################
#retourne une liste de fichiers qui doivent rester privs, cd qu'on doit supprimer des dossiers publis
def getPrivateFilesList():
  privateFiles = [
      "log.txt", "BuildsFile.txt",
      "index.hhk", "toc.hhc", "Cover.htm", "PICOLOV16H264.htm", "PICOLOV4H264PCI104.htm",
      "container.htm", "DOMINO series.htm", "Empty.htm",
      "Euresys Boards Documentation.htm", "GRABLINK series.htm",
      "html_frameset.htm", "LACI.htm", "LDCI.htm", "MC SP.htm",
      "PICOLOV16H264 SP.htm", "MultiCam.htm", "Normal.htm",
      "topic.htm", "Oe SP.htm", "Open eVision ActiveX Reference.htm",
      "Open eVision C++ Reference.htm", "Open eVision Documentation.htm",
      "Open eVision NET Reference.htm", "Open eVision User Guide.htm",
      "Parameter.htm", "PICOLO series.htm", "stylesheet.css",
      "PrivateStrings.txt"
  ]
  privateFiles += glob.glob('*.py*')
  privateFiles += glob.glob('*.hhp')
  privateFiles += glob.glob('*.bat')
  privateFiles += glob.glob('*.chm')
  return privateFiles



#################################################################################################
#retourne une liste de strings qui doivent tre supprimes des fichiers publis
def getPrivateStringsList():
  privateStrings = readLinesFromFile("PrivateStrings.txt")
  return privateStrings



#################################################################################################
def findDocumentationVersion():
  pattern = re.compile(r'.*?(\d+)\.(\d+)\.?(\d+)?\s*\(doc build (\d+)\)')
  for f in os.listdir('.'):
    if getFileExtension(f) == '.htm':
      contents = readFromFile(f)
      splitVersion = pattern.search(contents).groups()
      if splitVersion:
        return splitVersion



#################################################################################################
def getDocumentationBuild():
  pattern = re.compile(r'\(doc build (\d+)\)')
  for f in os.listdir('.'):
    if getFileExtension(f) == '.htm':
      contents = readFromFile(f)
      docbuild = pattern.search(contents).group(1)
      print "docbuild = " + docbuild
      return docbuild




#################################################################################################
def getDocumentationVersion():
  splitVersion = findDocumentationVersion()
  version = '.'.join([str(i) for i in splitVersion]).replace('None', '0')
  print "version = " + version
  return version



#################################################################################################
#retourne 0 si x = y, -1 si x < y, 1 si x > y (comparaison utilise pour tri alphabtique, case-insensitive)
def cmpLower(x, y):
  return cmp(x[0].lower(), y[0].lower())



#################################################################################################
###browser le rpertoire courant
##for f in os.listdir('.'):

###browser le rpertoire courant + les sous-rpertoires
##for root, dirs, files in os.walk("."):
##  for f in files:
##    filePath = os.path.join(root, f)




      